import React from 'react';
import agent from '../../agent';
import { connect } from 'react-redux';
import { DELETE_COMMENT } from '../../constants/actionTypes';
import swal from 'sweetalert';

const mapDispatchToProps = dispatch => ({
  onClick: (payload, commentId) =>
    dispatch({ type: DELETE_COMMENT, payload, commentId })
});

const DeleteButton = props => {
  const del = () => {
    const payload = agent.Comments.delete(props.slug, props.commentId);
    props.onClick(payload, props.commentId);
  };

  function deleteComment() {
    swal({
      title: "Are you sure?",
      text: "Comment will be deleted permanently!",
      buttons: true,
      dangerMode: true,
    })
    .then((willDelete) => {
      if (willDelete) {
        swal("Your comment has been deleted!", {
          icon: "success",
          content: del()
        });
      } else {
        swal("Canceled!");
      }
    });
  }
  if (props.show) {
    return (
      <span className="mod-options">
        <i className="ion-trash-a" onClick={()=>deleteComment()}></i>
      </span>
    );
  }
  return null;
};

export default connect(() => ({}), mapDispatchToProps)(DeleteButton);
